from Achievement import Achievement
from odict import odict

# == ACHIEVEMENTGROUP CLASS =============================
class AchievementGroup:
    __id = None
    __name = None
    __description = None
    __achievements = None
  
    def __init__(self, newID, newName, newDescription):
        self.__id = newID
        self.__name = newName
        self.__description = newDescription
        self.__achievements = odict()
    
    def __getattr__(self, name):
        if name == "id":
            return self.__id
        elif name == "name":
            return self.__name
        elif name == "description":
            return self.__description
        elif name == "achievements":
            return self.__achievements
        elif name in self.__dict__.keys():
            return self.__dict__[name]
        else:
            raise AttributeError, name
    
    def __setattr__(self, name, value):
        if name == "id":
            self.__id = value
        elif name == "name":
            self.__name = value
        elif name == "description":
            self.__description = value
        elif name != "achievements":
            self.__dict__[name] = value
    
    def __getitem__(self, name):
        if name in self.__achievements.keys():
            return self.__achievements[name]
        else:
            return None
    
    def __setitem__(self, name, value):
        if type(value) is tuple:
            if not name in self.__achievements.keys():
                if value[-1] == value[1]:
                    self.__achievements[name] = Achievement(self.__id, name, value[0], value[1])
                else:
                    self.__achievements[name] = Achievement(self.__id, name, value[0], value[1], value[2])
        else:
            self.__achievements[name] = value
    
    def __delitem__(self, key):
        if key in self.__achievements.keys():
            del self.__achievements[key]
   
    def getAchievements(self):
        return self.__achievements
# =======================================================